(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('moment'), require('@angular/core'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('angular-icalendar', ['exports', 'moment', '@angular/core', '@angular/common/http'], factory) :
    (factory((global['angular-icalendar'] = {}),global.moment_,global.ng.core,global.ng.common.http));
}(this, (function (exports,moment_,core,http) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m)
            return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length)
                    o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/models.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var moment = moment_;
    /**
     * @abstract
     */
    var /**
     * @abstract
     */ CalendarObject = /** @class */ (function () {
        function CalendarObject() {
        }
        /**
         * @param {?} icsString
         * @return {?}
         */
        CalendarObject.prototype.selfParse = /**
         * @param {?} icsString
         * @return {?}
         */
            function (icsString) {
                var e_1, _a;
                /** @type {?} */
                var firstLine = true;
                /** @type {?} */
                var subObject = false;
                /** @type {?} */
                var childObjectClass = '';
                /** @type {?} */
                var childIcsString = '';
                icsString = icsString.replace(/\n /g, "");
                try {
                    for (var _b = __values(icsString.split('\n')), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var line = _c.value;
                        // Current Line
                        /** @type {?} */
                        var sepIndex = line.indexOf(":");
                        /** @type {?} */
                        var property = line.substring(0, sepIndex);
                        /** @type {?} */
                        var value = line.substring(sepIndex + 1, line.length);
                        if (value)
                            value = value.slice(0, -1);
                        childIcsString += line + '\n';
                        // Child Object Parsing
                        if ((property == 'END') && (value == childObjectClass)) {
                            subObject = false;
                            switch (childObjectClass) {
                                case 'VEVENT':
                                    this.addChildren('VEVENT', new Event(childIcsString));
                                    break;
                                case 'VJOURNAL':
                                    this.addChildren('VJOURNAL', new Journal(childIcsString));
                                    break;
                                case 'VTODO':
                                    this.addChildren('VTODO', new Todo(childIcsString));
                                    break;
                                case 'VALARM':
                                    this.addChildren('VALARM', new Alarm(childIcsString));
                                    break;
                                case 'VTIMEZONE':
                                    this.addChildren('VTIMEZONE', new Timezones(childIcsString));
                                    break;
                                case 'STANDARD':
                                    this.addChildren('STANDARD', new Timezone(childIcsString));
                                    break;
                                case 'DAYLIGHT':
                                    this.addChildren('DAYLIGHT', new Timezone(childIcsString));
                                    break;
                            }
                        }
                        if ((property == 'BEGIN') && (!firstLine) && (!subObject)) {
                            childObjectClass = value;
                            childIcsString = '';
                            subObject = true;
                        }
                        // Set the properties of current object
                        else {
                            this.setProperty(property, value);
                        }
                        // First Line
                        if (firstLine) {
                            firstLine = false;
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            };
        return CalendarObject;
    }());
    /**
     * @abstract
     */
    var /**
     * @abstract
     */ EventTodoJournalComponent = /** @class */ (function (_super) {
        __extends(EventTodoJournalComponent, _super);
        function EventTodoJournalComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
        EventTodoJournalComponent.prototype.setProperty = /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
            function (property, value) {
                switch (property) {
                    case 'DTSTAMP':
                        this.dtstamp = moment(value);
                        break;
                    case 'LAST-MODIFIED':
                        this.lastmod = moment(value);
                        break;
                    case 'DTSTART':
                        this.dtstart = moment(value);
                        break;
                    case 'CREATED':
                        this.created = moment(value);
                        break;
                    case 'DESCRIPTION':
                        this.description = value;
                        break;
                    case 'SUMMARY':
                        this.summary = value;
                        break;
                    case 'RRULE':
                        this.rrule = value;
                        break;
                }
            };
        return EventTodoJournalComponent;
    }(CalendarObject));
    /**
     * @abstract
     */
    var /**
     * @abstract
     */ EventTodoComponent = /** @class */ (function (_super) {
        __extends(EventTodoComponent, _super);
        function EventTodoComponent() {
            var _this = _super.call(this) || this;
            _this.resources = new Array();
            _this.alarm = new Array();
            return _this;
        }
        /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
        EventTodoComponent.prototype.setProperty = /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
            function (property, value) {
                _super.prototype.setProperty.call(this, property, value);
                switch (property) {
                    case 'PRIORITY':
                        this.priority = value;
                        break;
                }
            };
        /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
        EventTodoComponent.prototype.addChildren = /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
            function (cls, object) {
                switch (cls) {
                    case 'VALARM':
                        this.alarm.push(object);
                        break;
                }
            };
        return EventTodoComponent;
    }(EventTodoJournalComponent));
    var Alarm = /** @class */ (function (_super) {
        __extends(Alarm, _super);
        function Alarm(icsString) {
            var _this = _super.call(this) || this;
            _this.attendee = new Array();
            _this.selfParse(icsString);
            return _this;
        }
        /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
        Alarm.prototype.setProperty = /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
            function (property, value) {
                switch (property) {
                    case 'ACTION':
                        this.action = value;
                        break;
                    case 'DESCRIPTION':
                        this.description = value;
                        break;
                    case 'TRIGGER':
                        this.trigger = value;
                        break;
                }
            };
        /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
        Alarm.prototype.addChildren = /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
            function (cls, object) { };
        return Alarm;
    }(CalendarObject));
    var Event = /** @class */ (function (_super) {
        __extends(Event, _super);
        function Event(icsString) {
            var _this = _super.call(this) || this;
            _this.selfParse(icsString);
            return _this;
        }
        /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
        Event.prototype.setProperty = /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
            function (property, value) {
                _super.prototype.setProperty.call(this, property, value);
                switch (property) {
                    case 'DTEND':
                        this.dtend = moment(value);
                        break;
                    case 'TRANSP':
                        this.transp = value;
                        break;
                }
            };
        return Event;
    }(EventTodoComponent));
    var Todo = /** @class */ (function (_super) {
        __extends(Todo, _super);
        function Todo(icsString) {
            var _this = _super.call(this) || this;
            _this.selfParse(icsString);
            return _this;
        }
        /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
        Todo.prototype.setProperty = /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
            function (property, value) {
                _super.prototype.setProperty.call(this, property, value);
                switch (property) {
                    case 'COMPLETED':
                        this.completed = value;
                        break;
                    case 'DUE':
                        this.due = moment(value);
                        break;
                    case 'PERCENT':
                        this.percent = value;
                        break;
                }
            };
        return Todo;
    }(EventTodoComponent));
    var Journal = /** @class */ (function (_super) {
        __extends(Journal, _super);
        function Journal(icsString) {
            var _this = _super.call(this) || this;
            _this.selfParse(icsString);
            return _this;
        }
        /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
        Journal.prototype.addChildren = /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
            function (cls, object) { };
        return Journal;
    }(EventTodoJournalComponent));
    var Timezone = /** @class */ (function (_super) {
        __extends(Timezone, _super);
        function Timezone(icsString) {
            var _this = _super.call(this) || this;
            _this.selfParse(icsString);
            return _this;
        }
        /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
        Timezone.prototype.setProperty = /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
            function (property, value) {
                switch (property) {
                    case 'TZNAME':
                        this.tzname = value;
                        break;
                    case 'TZOFFSETFROM':
                        this.tzoffsetfrom = value;
                        break;
                    case 'TZOFFSETTO':
                        this.tzoffsetto = value;
                        break;
                }
            };
        /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
        Timezone.prototype.addChildren = /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
            function (cls, object) { };
        return Timezone;
    }(CalendarObject));
    var Timezones = /** @class */ (function (_super) {
        __extends(Timezones, _super);
        function Timezones(icsString) {
            var _this = _super.call(this) || this;
            _this.selfParse(icsString);
            return _this;
        }
        /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
        Timezones.prototype.setProperty = /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
            function (property, value) {
                switch (property) {
                    case 'TZID':
                        this.tzid = value;
                        break;
                }
            };
        /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
        Timezones.prototype.addChildren = /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
            function (cls, object) {
                switch (cls) {
                    case 'STANDARD':
                        this.standard = object;
                        break;
                    case 'DAYLIGHT':
                        this.daylight = object;
                        break;
                }
            };
        return Timezones;
    }(CalendarObject));
    var Calendar = /** @class */ (function (_super) {
        __extends(Calendar, _super);
        function Calendar(icsString) {
            var _this = _super.call(this) || this;
            _this.events = [];
            _this.timezones = [];
            _this.selfParse(icsString);
            return _this;
        }
        /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
        Calendar.prototype.setProperty = /**
         * @param {?} property
         * @param {?} value
         * @return {?}
         */
            function (property, value) {
                switch (property) {
                    case 'PRODID':
                        this.prodid = value;
                        break;
                    case 'VERSION':
                        this.version = value;
                        break;
                    case 'CALSCALE':
                        this.calscale = value;
                        break;
                }
            };
        /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
        Calendar.prototype.addChildren = /**
         * @param {?} cls
         * @param {?} object
         * @return {?}
         */
            function (cls, object) {
                switch (cls) {
                    case 'VEVENT':
                        this.events.push(object);
                        break;
                    case 'VTIMEZONE':
                        this.timezones.push(object);
                        break;
                }
            };
        /**
         * @param {?} from
         * @param {?} to
         * @return {?}
         */
        Calendar.prototype.getEvents = /**
         * @param {?} from
         * @param {?} to
         * @return {?}
         */
            function (from, to) {
                var e_2, _a;
                /** @type {?} */
                var events = Array();
                try {
                    for (var _b = __values(this.events), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var event_1 = _c.value;
                        if ((event_1.dtend >= from) && (event_1.dtstart <= to)) {
                            events.push(event_1);
                        }
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                return events;
            };
        return Calendar;
    }(CalendarObject));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/angular-icalendar.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var IcsParserService = /** @class */ (function () {
        function IcsParserService() {
        }
        /**
         * @param {?} ics
         * @return {?}
         */
        IcsParserService.prototype.parseICS = /**
         * @param {?} ics
         * @return {?}
         */
            function (ics) {
                return new Calendar(ics);
            };
        IcsParserService.decorators = [
            { type: core.Injectable }
        ];
        return IcsParserService;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/angular-icalendar.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularIcalendarModule = /** @class */ (function () {
        function AngularIcalendarModule() {
        }
        AngularIcalendarModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [],
                        imports: [
                            http.HttpClientModule
                        ],
                        providers: [
                            IcsParserService
                        ],
                        exports: []
                    },] }
        ];
        return AngularIcalendarModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: angular-icalendar.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.IcsParserService = IcsParserService;
    exports.AngularIcalendarModule = AngularIcalendarModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=angular-icalendar.umd.js.map