declare abstract class CalendarObject {
    abstract setProperty(property: string, value: any): any;
    abstract addChildren(cls: string, object: any): any;
    selfParse(icsString: string): void;
}
declare abstract class EventTodoJournalComponent extends CalendarObject {
    attach: Array<any>;
    attendee: Array<any>;
    categories: Array<any>;
    class: string;
    comment: Array<any>;
    contact: Array<any>;
    created: any;
    description: string;
    dtstamp: any;
    dtstart: any;
    exdate: any;
    exrule: any;
    lastmod: any;
    organizer: any;
    rdate: any;
    recurid: number;
    related: Array<any>;
    rrule: Array<any>;
    rstatus: Array<any>;
    seq: any;
    status: any;
    summary: any;
    uld: any;
    url: any;
    xprop: any;
    setProperty(property: string, value: any): void;
}
declare abstract class EventTodoComponent extends EventTodoJournalComponent {
    duration: any;
    geo: any;
    location: any;
    priority: any;
    resources: Array<any>;
    alarm: Array<any>;
    constructor();
    setProperty(property: string, value: any): void;
    addChildren(cls: string, object: any): void;
}
export declare class Alarm extends CalendarObject {
    action: string;
    attach: string;
    attendee: Array<any>;
    description: string;
    summary: string;
    trigger: string;
    constructor(icsString: string);
    setProperty(property: string, value: any): void;
    addChildren(cls: string, object: any): void;
}
export declare class Event extends EventTodoComponent {
    dtend: any;
    transp: any;
    constructor(icsString: string);
    setProperty(property: string, value: any): void;
}
export declare class Todo extends EventTodoComponent {
    completed: boolean;
    due: any;
    percent: any;
    constructor(icsString: string);
    setProperty(property: string, value: any): void;
}
export declare class Journal extends EventTodoJournalComponent {
    constructor(icsString: string);
    addChildren(cls: string, object: any): void;
}
export declare class Timezone extends CalendarObject {
    dtstart: any;
    tzname: string;
    tzoffsetfrom: any;
    tzoffsetto: any;
    constructor(icsString: string);
    setProperty(property: string, value: any): void;
    addChildren(cls: string, object: any): void;
}
export declare class Timezones extends CalendarObject {
    lastmod: any;
    tzid: any;
    tzurl: any;
    standard: Timezone;
    daylight: Timezone;
    constructor(icsString: string);
    setProperty(property: string, value: any): void;
    addChildren(cls: string, object: any): void;
}
export declare class Calendar extends CalendarObject {
    calscale: string;
    method: string;
    version: string;
    xprop: string;
    prodid: string;
    events: Array<Event>;
    timezones: Array<Timezones>;
    constructor(icsString: string);
    setProperty(property: string, value: any): void;
    addChildren(cls: string, object: any): void;
    getEvents(from: any, to: any): Array<Event>;
}
export {};
